<?
 /**
 * Extra Controller for Pressbackup.
 *
 * This Class provide misc function that are called automaticaly at some point
 *
 * Licensed under The GPL v2 License
 * Redistributions of files must retain the above copyright notice.
 *
 * @link				http://pressbackup.com
 * @package		controlers
 * @subpackage	controlers.extra
 * @since			0.5
 * @license			GPL v2 License
 */

class PressbackExtra {

	/**
	 * Check if the scheluded taks is active and active otherwise
	 * Also check for missing preferences added between versons
	 * Note: this function its called at the init of the plugin
	*/
	function checks () {

		//tools
		global $pressbackup;
		$preferences= get_option('pressbackup_preferences');

		$pressbackup->import('misc.php');
		$misc = new pressbackup_misc();

		//set the type of service use to get/show backups
		$service = $misc->current_service();

		//set the type of credential to see what option show in this page
		$credentials = ($service)?true:false;

		//fix to missing schedule
		if ($credentials && !$ns=wp_next_scheduled('pressback_backup_start_cronjob')){
			$pressbackup->import('backup_functions.php');
			$pb = new pressbackup_backup();
			$pb->add_schedule();
		}

		//check for new preferences
		$need_update = false;
		if (!isset($preferences['pressbackup']['compatibility']['background'])){
			$preferences['pressbackup']['compatibility']['background']=10;
			$need_update = true;
		}
		if (!isset($preferences['pressbackup']['compatibility']['zip'])){
			$preferences['pressbackup']['compatibility']['zip'] = 10;
			$need_update = true;
		}
		if (!isset($preferences['pressbackup']['local']['path'])){
			$preferences['pressbackup']['local']['path'] = '';
			$need_update = true;
		}
		if (!isset($preferences['pressbackup']['dropbox']['credential'])){
			$preferences['pressbackup']['dropbox']['credential'] = '';
			$need_update = true;
		}
		if (!isset($preferences['pressbackup']['s3']['bucket_name'])){
			$preferences['pressbackup']['s3']['bucket_name'] = '';
			$need_update = true;
		}

		if (!isset($preferences['pressbackup']['backup_advanced']['activated'])){
			$preferences['pressbackup']['backup_advanced']['activated'] = false;
			$preferences['pressbackup']['backup_advanced']['db']= array('time' => null, 'last_date' => null);
			$preferences['pressbackup']['backup_advanced']['plugins']= array('time' => null, 'last_date' => null);
			$preferences['pressbackup']['backup_advanced']['themes']= array('time' => null, 'last_date' => null);
			$preferences['pressbackup']['backup_advanced']['uploads']= array('time' => null, 'last_date' => null);
			$need_update = true;
		}

		if($need_update) {
			update_option('pressbackup_preferences',$preferences);
		}

	}

	/**
	 * Restore the permalinks
	 *
	 * called after a restore is done
	 * Note: this function its called at the admin init
	 */
	function restore_htaccess () {

		//tools
		global $pressbackup;
		global $wp_rewrite;
		$preferences= get_option('pressbackup_preferences');

		if(isset($preferences['pressbackup']['restore']))
		{
			$wp_rewrite->flush_rules();
			unset($preferences['pressbackup']['restore']);
			update_option('pressbackup_preferences',$preferences);
		}
		return true;
	}

}
?>
