<?php

	class PressbackupDropbox {

		private  $API_VERSION = '1';

		public  $response_code= null;
		public  $response_error= null;
		public  $buffer= '';
		private  $tmp_file= null;
		private  $fp= null;
		public $OAuth = null;

		public function __construct($oauth_token=null, $oauth_token_secret=null) {
			$this->OAuth = new PressbackupOAuth("ri8fmrz5q9h6tlb","m7zcjk11doevbkj");
			if ($oauth_token !== null && $oauth_token_secret!== null){
				$this->OAuth->setTokens($oauth_token,$oauth_token_secret);
			}
		}

		//callback  is an array that indicate where to redirect after authenticate 
		// callback example array('menu_type'=>'settings', 'controller'=>'settings', 'function'=>'config_settings')
		public function auth($callback)
		{
			global $pressbackup;

			$url = "https://api.dropbox.com/1/oauth/request_token";

			$this->OAuth->setValues();

			$oauth_signature = $this->OAuth->calcSignature("POST",$url);

			$this->OAuth->setValues('oauth_signature', $oauth_signature);
			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'post' => "",
				'header' => array('Content-Length: 0','Authorization: '.$headers)
			);
			$dropbox_response =  $this->call($args);

			//parse & obtain the tokens on $tokens array
			$dropbox_response = explode("&",$dropbox_response);

			$tokens_aux = explode("=",$dropbox_response[0]);
			$tokens['oauth_token_secret'] = $tokens_aux[1];

			$tokens_aux = explode("=",$dropbox_response[1]);
			$tokens['oauth_token'] = $tokens_aux[1];

			//make the url to call
			$callback[0] = $tokens['oauth_token_secret'];
			$url_to_call = $pressbackup->Path->router($callback);

			//remove &amp; to form the URL
			$url_to_call = urlencode(str_replace("&amp;","&",$url_to_call));

			$pressbackup->redirect("https://www.dropbox.com/1/oauth/authorize?oauth_token=".$tokens['oauth_token']."&oauth_callback=".$url_to_call);
		}

		public function get_access_token($oauth_token=null,$oauth_token_secret=null){

			$url = "https://api.dropbox.com/1/oauth/access_token";

			$this->OAuth->setValues();

			$this->OAuth->setTokens($oauth_token,$oauth_token_secret);

			$this->OAuth->setValues('oauth_token', $oauth_token);

			$oauth_signature = $this->OAuth->calcSignature("POST",$url);

			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'post' =>"",
				'header' => array('Content-Length: 0','Content-type: application/x-www-form-urlencoded','Authorization: '.$headers)
			);

			$dropbox_response =  $this->call($args);

			//parse & obtain the tokens on $tokens array
			$dropbox_response = explode("&",$dropbox_response);

			$tokens_aux = explode("=",$dropbox_response[0]);
			$tokens['oauth_token_secret'] = $tokens_aux[1];

			$tokens_aux = explode("=",$dropbox_response[1]);
			$tokens['oauth_token'] = $tokens_aux[1];

			$this->OAuth->setTokens($tokens['oauth_token'],$tokens['oauth_token_secret']);

			return $tokens;
		}

		public function get_info(){

			$url = "https://api.dropbox.com/1/account/info";

			$this->OAuth->setValues();

			$oauth_signature = $this->OAuth->calcSignature("GET",$url);
			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'header' => array('Content-Length: 0','Authorization: '.$headers)
			);

			return $this->call($args);
		}

		public function putFile($file)
		{
			return $this->putFile_fp($file);
		}

		public function putFile_fp($file)
		{
			$name = basename($file);

			$url = "https://api-content.dropbox.com/1/files_put/sandbox/".$name;

			$this->OAuth->setValues();

			$oauth_signature = $this->OAuth->calcSignature("PUT",$url);
			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'header' => array('Authorization: '.$headers)
			);

			//try to send the chunk 5 times
			$sent = false; $count=0;
			while (!$sent && $count < 3) {
				$this->fp = array( 'file' => @fopen($file, 'rb'), 'size' => filesize($file));
				$sent = $this->call($args);
				$count ++;
				sleep(1);
			}

			if(!$sent || !in_array($this->response_code, array(200, 204)))
			{
				return false;
			}
			return true;
		}

		public function getFile($name,$saveon)
		{
			$url = "https://api-content.dropbox.com/1/files/sandbox/".$name;

			$this->OAuth->setValues();

			$oauth_signature = $this->OAuth->calcSignature("GET",$url);
			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'header' => array('Content-Length: 0','Authorization: '.$headers),
				'saveon'=>$saveon,
			);

			return $this->call($args);
		}

		public  function deleteFile($file)
		{
			$url = "https://api.dropbox.com/1/fileops/delete";

			$this->OAuth->setValues();

			$this->OAuth->setParams("root","sandbox");
			$this->OAuth->setParams("path",$file);

			$oauth_signature = $this->OAuth->calcSignature("POST",$url,true);

			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$body = $this->OAuth->getBody();

			$args = array(
				'url' => $url,
				'post' => $body["result"],
				'header' => array('Content-type: application/x-www-form-urlencoded','Authorization: '.$headers)
			);

			$this->call($args);print_r($this);
		}

		public function getFilesList(){

			$url = "https://api.dropbox.com/1/metadata/sandbox/";

			$this->OAuth->setValues();

			$oauth_signature = $this->OAuth->calcSignature("GET",$url);
			$this->OAuth->setValues('oauth_signature', $oauth_signature);

			$headers = $this->OAuth->makeHeader();

			$args = array(
				'url' => $url,
				'header' => array('Content-Length: 0','Authorization: '.$headers)
			);

			return $this->call($args);
		}

		private function call($args)
		{
			//init settings
			date_default_timezone_set('UTC');
			$this->buffer = '';
			$this->response_code= null;
			$this->response_error= null;
			$this->tmp_file= null;

			if(!isset($args['header']))
			{
				$args['header'] = array();
			}

			$curl_handle = null;
			$curl_handle = curl_init(false);
			curl_setopt($curl_handle, CURLOPT_FRESH_CONNECT, true );

			curl_setopt($curl_handle, CURLOPT_URL,  $args['url']);
			curl_setopt($curl_handle, CURLOPT_HEADER, 0 );
			curl_setopt($curl_handle, CURLOPT_USERAGENT, 'Pro/php');
			curl_setopt($curl_handle, CURLOPT_HTTPHEADER, $args['header']);
			curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);


			curl_setopt($curl_handle, CURLOPT_NOSIGNAL, true);
			curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 60);
			//curl_setopt($curl_handle, CURLOPT_TIMEOUT, 100);

			curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($curl_handle, CURLOPT_MAXREDIRS, 2);

			curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 0);

			curl_setopt($curl_handle, CURLOPT_READFUNCTION, array($this, '__responseReadCallback'));
			curl_setopt($curl_handle, CURLOPT_WRITEFUNCTION, array($this, '__responseWriteCallback'));
			curl_setopt($curl_handle, CURLOPT_HEADERFUNCTION, array($this, '__responseHeaderCallback'));

			if (isset($args['post']))
			{
				curl_setopt($curl_handle, CURLOPT_POST, 1);
				if($args['post']){
					curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $args['post']);
				}
			}

			if (is_array($this->fp))
			{
				curl_setopt($curl_handle, CURLOPT_PUT, true);
				curl_setopt($curl_handle, CURLOPT_INFILE, $this->fp['file']);
				//curl_setopt($curl_handle, CURLOPT_BUFFERSIZE, 128);
				if ($this->fp['size'] >= 0) {
					curl_setopt($curl_handle, CURLOPT_INFILESIZE, $this->fp['size']);

					global $pressbackup;
					@$pressbackup->Session->write( 'sent.percent', '0|'.$this->fp['size']);
				}
			}

			else if (isset($args['saveon']))
			{
				$this->tmp_file = @fopen($args['saveon'], 'wb');
			}

			if (!curl_exec($curl_handle))
			{
				$this->response_code= curl_errno($curl_handle);
				$this->response_error=curl_error($curl_handle);
				curl_close($curl_handle);

				if ($this->tmp_file != null){
					@fclose($this->tmp_file); @unlink($args['saveon']);
				}
				if (is_array($this->fp)){
					@fclose($this->fp['file']);
					$this->fp = null;
				}
				return false;
			}
			else
			{
				$this->response_code =curl_getinfo($curl_handle, CURLINFO_HTTP_CODE);
				curl_close($curl_handle);

				//close resources
				if ($this->tmp_file != null ){
					@fclose($this->tmp_file);
					$this->tmp_file = null;
				}
				if (is_array($this->fp)){
					@fclose($this->fp['file']);
					$this->fp = null;
				}

				//check for error from server
				if (in_array($this->response_code, array(401, 404, 500, 505)))
				{
					if ($this->response_code == 401){ $this->response_error = "Wrong Credentials";}
					if ($this->response_code == 404){ $this->response_error = "Object Not found";}
					if ($this->response_code == 500){ $this->response_error = "Server Error";}
					if ($this->response_code == 505){ $this->response_error = "Server Error";}

					if(isset($args['saveon'])) {
						@unlink($args['saveon']);
					}

					return false;
				}

				//parse when ok
				return $this->parse($this->buffer);
			}
		}

		private function __responseReadCallback(&$curl, $fp, $len) {
			if (!is_array($this->fp) || feof($this->fp['file'])) {return '';}
			else{
				global $pressbackup;
				@$pressbackup->Session->write( 'sent.percent', (@ftell($this->fp['file'])).'|'.$this->fp['size']);

				return fread($this->fp['file'], $len);
			}
		}

		private function __responseWriteCallback(&$curl, &$data) {
			if ( $this->tmp_file != null)
				return fwrite($this->tmp_file, $data);
			else
				$this->buffer .= $data;
				return strlen($data);
		}

		private function __responseHeaderCallback(&$curl, &$data) {
			return strlen($data);
		}

		private function parse ($buffer)
		{
			$response = true;
			if (!class_exists (Services_JSON)) {
				require_once("json.php");
			}
			$json_parser = new Services_JSON;

			if($buffer) { $response = $buffer;}
			if( $json = $json_parser->decode($buffer))
			{
				$response = $json;
			}
			return $response;
		}

	}

	class PressbackupOAuth {
		private $oauth_params = array();
		private $oauth_values = array();
		private $keys = array('consumer_key'=>null, 'shared_secret'=>null);
		private $tokens = null;

		public function __construct($consumer_key=null, $shared_secret = null) {
			if(($shared_secret !== null )&&($shared_secret !== null )){
				$this->keys['consumer_key'] = $consumer_key;
				$this->keys['shared_secret'] = $shared_secret;
			}
		}

		function setTokens($oauthToken,$oauthTokenSecret){
			$this->tokens = array('oauth_token'=>$oauthToken, 'oauth_token_secret'=>$oauthTokenSecret);
		}

		function setValues($key=null, $value=null){

			date_default_timezone_set('UTC');

			$timestamp = strtotime("now");
			$nonce = "121212"+$timestamp + $this->randomFloat();

			if ($key !== null && $value !== null )
			{
				//set the pair name|value
				$a_pair= array_shift($this->oauth_values);
				array_push($this->oauth_values, $key.'|'.$value);
				array_push($this->oauth_values, $a_pair);
			}
			else
			{
				//load default values
				$this->oauth_params =array();
				$this->oauth_values = array(
					"oauth_nonce|" . $nonce,
					"oauth_signature_method|" . "HMAC-SHA1",
					"oauth_timestamp|" . $timestamp,
					"oauth_consumer_key|" . $this->keys['consumer_key'],
					"oauth_version|" . "1.0"
				);
				// if user id loged in we must include the token
				if($this->tokens !== null)
				{
					$a_pair = array_shift($this->oauth_values);
					array_push($this->oauth_values, 'oauth_token' . '|' . $this->tokens['oauth_token']);
					array_push($this->oauth_values, $a_pair);
				}
			}
		}

		function setParams($key, $value){
			array_push($this->oauth_params, rawurlencode($key).'|'.rawurlencode($value));
		}

		function calcSignature($method, $url,$print=false){
			// read RFC 5849 (oAuth 1.0)
			// http://tools.ietf.org/html/rfc5849#section-3.4.1

			//url without get params
			$urlWithoutParams= $url;
			$url_aux = explode('?',$url);
			$urlWithoutParams=$url_aux[0];

			//oauth token secret (if user is loged-in)
			$ots = ''; if($this->tokens !== null) { $ots = $this->tokens['oauth_token_secret']; }

			//first base string setings method & base string URI
			$base_string = array ($method,urlencode($urlWithoutParams)); 

			//Request Parameters
			$params = array_merge($this->oauth_params, $this->oauth_values); 

			sort($params);

			for($i=0; $i< count($params); $i++) 
			{
				$params[$i] = str_replace("|","=",$params[$i]);
			}

			$params = implode("&",$params);
			$params = urlencode($params);

			//add request parameters to base string
			array_push($base_string, $params);
			$base_string = implode("&",$base_string);


			if($print){
				print_r($base_string);
			}

			//use HMAC-SHA1 to encript it 
			$signature = $this->hmac_sha1($this->keys['shared_secret']."&".$ots, $base_string);

			$signature = base64_encode($signature);

			return $signature;
		}

		function makeHeader(){
			//get values
			$values = $this->oauth_values;

			//make it as name="value"
			for($i =0; $i< count($values); $i++)
			{
				$a_pair = explode("|",$values[$i]);
				$a_pair[1]= '"' . rawurlencode($a_pair[1]) .  '"';
				$values[$i] = implode('=',$a_pair);
			}

			//add info
			$values[0]='OAuth ' . $values[0];

			//make header
			$heather = implode(', ',$values);
			return $heather;
		}

		function getBody(){
			$result = array();

			$params = $this->oauth_params;
			for($i=0; $i< count($params); $i++) 
			{
				$a_pair = explode("|",$params[$i]);

				$result[$a_pair[0]] = $a_pair[1];

				$params[$i] = implode('=',$a_pair);
			}

			ksort($result);

			$params = implode('&',$params);

			return array("result" => $params, "length"=>strlen($params));
		}

		//========================================MISC========================================
		function randomFloat($min = 0, $max = 1) {
				return $min + mt_rand() / mt_getrandmax() * ($max - $min);
		}

		function hmac_sha1($key, $data){
			return pack('H*', sha1(
			(str_pad($key, 64, chr(0x00)) ^ (str_repeat(chr(0x5c), 64))) .
			pack('H*', sha1((str_pad($key, 64, chr(0x00)) ^
			(str_repeat(chr(0x36), 64))) . $data))));

		}


	}



?>
